# HardyWeinbergTesting (HW_TEST)

## What is HW_TEST software?

   HW_TEST, a software developed for Microsoft Windows that can be managed without any difficulties by users with a minimum of programming skills and statistical/mathematical background, is a program that tests the null hypothesis of Hardy-Weinberg proportions using genotype data from autosomal genetic markers with two to twelve alleles.\
**NOTE:** All pertinent computer methods and mathematical/statistical details used in the program are described in the pdf user’s manual, available above.

## How to download the program?

   All files necessary to run the program can be downloaded into the user´s computer by simply clicking the **Clone or Download** link and then the **Download ZIP** one.\
  The program can also be obtained free of charge by email from the authors Renan B. Lemes (lemes.rb@usp.br) or Paulo A. Otto (otto@usp.br).\
**NOTE:** The unzipping of the downloaded "HardyWeinbergTesting-master.zip" file inside any location of the user's computer will result in the creation of a folder named "HardyWeinbergTesting-master" in the same location. This folder contains the user's pdf guide, the source code of the program and the folder HW_TEST. The program is executed by simply clicking the HW_TEST.exe executable file inside this folder HW_TEST. The main exe program, a tkn (tokenized) file and eight static and dynamic library files (HW_TEST.exe, HW_TEST.tkn, vbas31w.sll, vgui31w.sll, voflr31w.sll, vthk31w.dll, vtk1631w.dll, vtk3231w.dll, vvm31w.dll, and vvmt31w.dll) should be inside the folder HW_TEST. Even if another folder or location to house these files other than the folder HW_TEST is used, it is important that they remain inside the same computer location or folder; the absence of any of these files, that should always be kept physically together, will prevent the program from running. 

## How to cite the program?

DOI: https://doi.org/10.1590/1678-4685-GMB-2019-0380

- **MLA**\
Santos, Fernando Azenha Bautzer, Renan Barbosa Lemes, and Paulo Alberto Otto. "HW_TEST, a program for comprehensive HARDY-WEINBERG equilibrium testing." Genetics and Molecular Biology 43.2 (2020).

- **NBR6023**\
SANTOS, Fernando Azenha Bautzer; LEMES, Renan Barbosa; OTTO, Paulo Alberto. HW_TEST, a program for comprehensive HARDY-WEINBERG equilibrium testing. Genetics and Molecular Biology, v. 43, n. 2, 2020.

- **APA**\
Santos, F. A. B., Lemes, R. B., & Otto, P. A. (2020). HW_TEST, a program for comprehensive HARDY-WEINBERG equilibrium testing. Genetics and Molecular Biology, 43(2).

- **BibTex**\
@article{santos2020hw_test,\
  title={HW\_TEST, a program for comprehensive HARDY-WEINBERG equilibrium testing},\
  author={Santos, Fernando Azenha Bautzer and Lemes, Renan Barbosa and Otto, Paulo Alberto},\
  journal={Genetics and Molecular Biology},\
  volume={43},\
  number={2},\
  year={2020},\
  publisher={SciELO Brasil}\
}

## Credits

  The original VISUAL BASIC (© Microsoft Inc.) version of HW_TEST was developed by Fernando A. B. Santos and Paulo A. Otto (Santos and Otto, 2005; Santos, 2006) and subsequently rewritten and updated by Paulo A. Otto and Renan B. Lemes in Liberty BASIC v. 4.04 (© Shoptalk Systems 1992-2010, www.libertybasic.com), a programming language that runs in Windows Microsoft Operational System.

## Intellectual property

  The program is the intellectual property of its authors, and as such, any use of it or of the materials included in it must contain an explicit reference to their origin. Feedback from users is welcome and will be used to improve the program and to correct unforeseen flaws. As the program software is free, it comes however with no warranty.


## References

- Santos FAB and Otto PA. Pacote de programas computacionais visando a estimativa de parâmetros de interesse genético-populacional e o teste de hipóteses genéticas. 51th Congresso Nacional de Genética (Águas de Lindóia, SP). CDROM of Abstracts,  51th National Congress of Genetics, 2005 (gh738.pdf, p. 738).
- Santos FAB. Desenvolvimento de um pacote de programas visando a estimativa de parâmetros e o teste de hipóteses em genética de populações (Development of a package of programs aiming at the estimation of parameters and hypothesis testing in population genetics), MSc thesis, 166 pp., University of Sao Paulo, 2006. Available as a pdf archive at: https://teses.usp.br/teses/disponiveis/41/41131/tde-02122006-121406/en.php


## Updates and releases

25-Jun-2021 - HW_TEST_v.1.1 - Correction of minor errors in the software and in the manual typos.

This document last modified Friday, 25-Jun-2021
